# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, validator

class LuminesceViewResponse(BaseModel):
    """
    Readonly configuration for a Worker that calls a Luminesce view  # noqa: E501
    """
    type: Optional[StrictStr] = Field(None, description="The type of worker")
    name: Optional[StrictStr] = Field(None, description="Name of the view in Luminesce")
    __properties = ["type", "name"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('LuminesceView'):
            raise ValueError("must be one of enum values ('LuminesceView')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LuminesceViewResponse:
        """Create an instance of LuminesceViewResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if type (nullable) is None
        # and __fields_set__ contains the field
        if self.type is None and "type" in self.__fields_set__:
            _dict['type'] = None

        # set to None if name (nullable) is None
        # and __fields_set__ contains the field
        if self.name is None and "name" in self.__fields_set__:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LuminesceViewResponse:
        """Create an instance of LuminesceViewResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LuminesceViewResponse.parse_obj(obj)

        _obj = LuminesceViewResponse.parse_obj({
            "type": obj.get("type"),
            "name": obj.get("name")
        })
        return _obj
